format long
clear all
clc
%% System Parameters
numFrames = 1;    % Number of frames

%% Generate Data
tx.numCarriers = 48;
CyclicPrefixLength = 16;
PilotCarrierIndices = [12;26;40;54];

 %
 M = 4;                     % Size of signal constellation
 k = log2(M);                % Number of bits per symbol
numBits = tx.numCarriers*k*10e3;              % Number of bits to process
dataIn = randi([0 1], numBits, 1);  % Generate vector of binary data
dataInMatrix = reshape(dataIn, length(dataIn)/k, k); % Reshape data into binary 
dataSymbolsIn = bi2de(dataInMatrix,'left-msb');                 % Convert to integers
hMod = comm.PSKModulator('ModulationOrder',M,'PhaseOffset',pi./M);	% Defining modulator

modData = step(hMod, dataSymbolsIn);	% Modulating 

ofdmData = reshape(modData.', tx.numCarriers, length(modData)/tx.numCarriers);	% Reshaping modulated signal 

load pilot_default		% load pilot configuration
tam3 = pilot_default;
% Padding pilot
    tam1 = floor(size(ofdmData,2)./size(tam3,1));
    pilots = [];
    for ii = 1:tam1
        pilots = [pilots; tam3];
    end
    tam2 = mod(size(ofdmData,2),size(tam3,1));

   tx.pilots = [pilots; tam3(1:tam2,:)];
%
 numDataSymbols = length(modData)/tx.numCarriers;   
% Construct Modulator
            hDataMod = comm.OFDMModulator(...
                'FFTLength' ,           64,...
                'NumGuardBandCarriers', [6;5],...
                'InsertDCNull',         true, ...
                'PilotInputPort',       true,...
                'PilotCarrierIndices',  PilotCarrierIndices,...
                'CyclicPrefixLength',   CyclicPrefixLength,...
                'NumSymbols',           numDataSymbols,...
                'Windowing',true,...
                'WindowLength',12);    

% Modulate
r = step(hDataMod, ofdmData, tx.pilots');
        
         Resampling_factor = 16;
         frame = resample(r,Resampling_factor,1);
  
% Repeat frame
r = repmat(frame, numFrames, 1);
%   
       sampleFreq = Resampling_factor*20e6; 
%
centerFreq = 5.805*1e9; % 5.805 Ghz

savevsarecording( 'C:\users\Anh\Documents\MATLAB\thesis.mat', r, sampleFreq, centerFreq)
















